/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef __mcdefs_h__
#define __mcdefs_h__

/*
 * $Revision: 1.24 $
 */

/*
 * MagniComp common definetions
 * 
 * You should almost always include "mconfig.h" directly instead of this file.
 */
#include "options.h"		/* Need to include options.h before errno.h */
#include "mctypes.h"
#include <sys/errno.h>

/*
 * How to get system error string
 */
#if	defined(SYSERR)
#	undef SYSERR
#endif	/* SYSERR */
extern		int 			errno;
#define		SYSERR			strerror(errno)

/*
 * Number of demo days
 */
#define DEMODAYSNUM		60

/*
 * NULL
 */
#define CNULL			'\0'
#define C_NULL			CNULL

#define HERTZ			100				/* Hertz */
#define KHERTZ			10000				/* KiloHertz */
#define MHERTZ			1000000				/* MegaHertz */
#define GHERTZ			100000000			/* GigaHertz */
#define BYTES			((Large_t)1)			/* Bytes */
#define KBYTES			((Large_t)1024)			/* Kilobytes */
#define MBYTES			((Large_t)1048576)		/* Megabytes */
#define GBYTES			((Large_t)1073741824)		/* Gigabytes */

/*
 * Format Types
 */
#define FT_TREE			1		/* Hierarchical tree */
#define FT_PRETTY		FT_TREE		/* Backwards compat */
#define FT_REPORT		2		/* Report output */
#define FT_COLUMNS		3		/* Column format */
#define FormatType_t		int

/*
 * Output Encoding Types
 */
#define OE_TEXT			1		/* Human readable text */
#define OE_HTML			2		/* HTML */
#define EncodeType_t		int

/*
 * Definetion List names
 */
#define DL_SYSMODEL		"SysModel"	/* System Models */
#define DL_SUBSYSMODEL		"SubSysModel"	/* Sub System Models */
#define DL_SYSCONF		"SysConf"	/* System Configuration */
#define DL_KARCH		"KArch"		/* Kernel Architectures */
#define DL_CPU			"CPU"		/* CPU types */
#define DL_OBP			"OBP"		/* Open Boot Prom info */
#define DL_VPD			"VPD"		/* Vital Product Data */
#define DL_NETTYPE		"NetType"	/* Network Types */
#define DL_CATEGORY		"Category"	/* Categorys */
#define DL_PART			"Part"		/* Part info */
#define DL_TAPEINFO		"TapeInfo"	/* Tape info */
#define DL_KERNEL		"Kernel"	/* Kernel Variable */
#define DL_SCSI_DTYPE		"SCSIdtype"	/* SCSI Device Types */
#define DL_SCSI_COMP_ALG	"SCSIcompAlg"	/* Compression Algorithms */
#define DL_SCSI_FLAGS		"SCSIflags"	/* SCSI Flags */
#define DL_SCSI_ANSI		"SCSIansiVer"	/* SCSI ANSI Version */
#define DL_CDSPEED		"CDspeed"	/* CD Speeds */
#define DL_DOSPARTTYPES		"DosPartTypes"	/* DOS Partition Types */
#define DL_PCI_CLASS		"PCIclass"	/* PCI Class types */

/*
 * Report names
p */
#define R_NAME			"name"		/* Name description */
#define R_DESC			"desc"		/* Description info */
#define R_PART			"part"		/* Partition info */
#define R_CACHEINFO		"cacheinfo"	/* CPU cache info */
#define R_FILE			"file"		/* File info */
#define R_TOTALDISK		"totaldisk"	/* Total disk capacity */
#define R_CPUINFO		"cpuinfo"	/* CpuInfo_t data */

/*
 * Class Names
 */
#define CN_ALL			"All"
#define CN_GENERAL		"General"
#define CN_KERNEL		"Kernel"
#define CN_SYSCONF		"SysConf"
#define CN_DEVICE		"Device"
#define CN_HARDWARE		"Hardware"
#define CN_SOFTINFO		"Software"
#define CN_PARTITION		"Partition"
#define CN_PRINTER		"Printer"

#endif	/* __mcdefs_h__ */
