/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.5 $";
#endif

#include "defs.h"

/*
 * Get a nice Clock speed string
 */
extern char *GetClockStr(Amt, Unit)
    Large_t			Amt;
    Large_t			Unit;
{
    static char			Buff[64];

    Buff[0] = CNULL;

    if (Unit) {
	if (Unit == GHERTZ)
	    (void) snprintf(Buff, sizeof(Buff), "%.0f GHz", (float) Amt);
	else if (Unit == MHERTZ) {
	    if (Amt > KHERTZ)
		(void) snprintf(Buff, sizeof(Buff), "%.1f GHz",
				(float) mhz_to_ghz(Amt));
	    else
		(void) snprintf(Buff, sizeof(Buff), "%.0f MHz",
				(float) Amt);
	} else if (Unit == KHERTZ) {
	    if (Amt > MHERTZ)
		(void) snprintf(Buff, sizeof(Buff), "%.1f GHz",
				(float) khz_to_ghz(Amt));
	    else if (Amt > KHERTZ)
		(void) snprintf(Buff, sizeof(Buff), "%.0f MHz",
				(float) khz_to_mhz(Amt));
	    else
		(void) snprintf(Buff, sizeof(Buff), "%.0f KHz",
				(float) Amt);
	}
    }

    if (Buff[0] == CNULL) {
	if (Amt < KHERTZ)
	    (void) snprintf(Buff, sizeof(Buff), "%.0f Hz", (float) Amt);
	else if (Amt < MHERTZ)
	    (void) snprintf(Buff, sizeof(Buff), "%.0f KHz",
			    (float) hz_to_khz(Amt));
	else if (Amt < GHERTZ)
	    (void) snprintf(Buff, sizeof(Buff), "%.0f MHz",
			    (float) hz_to_mhz(Amt));
	else
	    (void) snprintf(Buff, sizeof(Buff), "%.1f GHz",
			    (float) hz_to_ghz(Amt));
    }

    return(Buff);
}
