/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

/*
 * Terminal Width functions
 */

#include "defs.h"
#if defined(HAVE_SYS_IOCTL_H)
# include <sys/ioctl.h>
#endif
#if defined(HAVE_TERMIOS_H)
# include <termios.h>
#endif
#if defined(HAVE_STDLIB_H)
# include <stdlib.h>
#endif

/*
 * Determine terminal width (columns)
 */
extern int TermWidth()
{
    char		       *cp;
    static int			Width;

    if (Width)
	return Width;

    if (!Width)
	if ((cp = getenv("COLUMNS")) && *cp)
	    Width = atoi(cp);

#if	defined(TIOCGWINSZ)
    if (!Width) {
	struct winsize		ws;

	if ((ioctl(1, TIOCGWINSZ, &ws) != -1) && ws.ws_col != 0)
	    Width = ws.ws_col;
    }
#endif	/* TIOCGWINSZ */

    if (!Width)
	Width = 80;

    return Width;
}
