#
# $Id: mcGetSize.pm,v 1.2 2001/05/30 16:13:23 mcooper Exp $
#
# GetSizeStr
#

package mcGetSize;
require 5.003;
require Exporter;

$BYTES		= 1;
$KBYTES		= 1024;
$MBYTES		= 1048576;
$GBYTES		= 1073741824;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   $BYTES $KBYTES $MBYTES $GBYTES
		   GetSizeStr
		  );
}

sub bytes_to_gbytes { return $_[0] / $GBYTES; }
sub bytes_to_mbytes { return $_[0] / $MBYTES; }
sub bytes_to_kbytes { return $_[0] / $KBYTES; }
sub mbytes_to_bytes { return $_[0] * $MBYTES; }
sub kbytes_to_mbytes { return $_[0] / $KBYTES; }
sub kbytes_to_gbytes { return $_[0] / $MBYTES; }
sub mbytes_to_gbytes { return $_[0] / $KBYTES; }

#
# Return a string indicated the size
#
sub GetSizeStr {
    my $Amt = shift;
    my $Unit = shift;

    if (!$Amt) {
	return;
    }

    my $String;

    if ($Unit) {
	if ($Unit == $GBYTES) {
	    $String = sprintf("%.0f GB", $Amt);
	} elsif ($Unit == $MBYTES) {
	    if ($Amt > $KBYTES) {
		$String = sprintf("%.1f GB", mbytes_to_gbytes($Amt));
	    } else {
		$String = sprintf("%.0f MB", $Amt);
	    }
	} elsif ($Unit == $KBYTES) {
	    if ($Amt > $MBYTES) {
		$String = sprintf("%.1f GB", kbytes_to_gbytes($Amt));
	    } elsif ($Amt > $KBYTES) {
		$String = sprintf("%.0f MB", kbytes_to_mbytes($Amt));
	    } else {
		$String = sprintf("%.0f KB", $Amt);
	    }
	}
    }

    if (!$String) {
	if ($Amt < $KBYTES) {
	    $String = sprintf("%.0f Bytes", $Amt);
	} elsif ($Amt < $MBYTES) {
	    $String = sprintf("%.0f KB", bytes_to_kbytes($Amt));
	} elsif ($Amt < $GBYTES) {
	    $String = sprintf("%.0f MB", bytes_to_mbytes($Amt));
	} else {
	    $String = sprintf("%.1f GB", bytes_to_gbytes($Amt));
	}
    }

    return $String;
}

1; # Make require/use happy
