/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.1 $";
#endif

/*
 * BSD/OS SCSI specific functions
 */

#include "defs.h"
#include "myscsi.h"
#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include "/sys/dev/scsi/scsi_ioctl.h"	/* Need for SCSI INQUIRY */

/*
 * Issue a SCSI command and return results
 */
extern int ScsiCmd(ScsiCmd)
     ScsiCmd_t		       *ScsiCmd;
{
    static char			Buff[SCSI_BUF_LEN];
    ScsiCdbG0_t		       *CdbPtr = NULL;
    static scsi_user_cdb_t	Cmd;

    if (!ScsiCmd || !ScsiCmd->Cdb || !ScsiCmd->CdbLen || 
	ScsiCmd->DevFD < 0 || !ScsiCmd->DevFile) {
	SImsg(SIM_DBG, "ScsiCmd: Bad parameters.");
	return(-1);
    }

    (void) memset(Buff, 0, sizeof(Buff));
    (void) memset(&Cmd, 0, sizeof(Cmd));

    (void) memcpy(Cmd.suc_cdb, ScsiCmd->Cdb, ScsiCmd->CdbLen);
    Cmd.suc_cdblen = ScsiCmd->CdbLen;
    Cmd.suc_data = (caddr_t) Buff;
    Cmd.suc_datalen = sizeof(Buff);
    Cmd.suc_timeout = MySCSI_CMD_TIMEOUT;	/* suc_timeout == seconds */
    Cmd.suc_flags = SUC_READ;

    /*
     * Issue command to device
     */
    errno = 0;
    CdbPtr = (ScsiCdbG0_t *) ScsiCmd->Cdb;
    (void) ioctl(ScsiCmd->DevFD, SCSIRAWCDB, &Cmd);

    if (Cmd.suc_sus.sus_status != 0 || errno > 0)  {
	SImsg(SIM_GERR, "%s: ioctl SCSI cmd 0x%x failed: %s", 
	      ScsiCmd->DevFile, CdbPtr->Cmd, SYSERR);
	return(-1);
    }

    ScsiCmd->Data = (void *) Buff;
    return(0);
}
